# encoding: utf-8

require 'thor'
require 'active_support/inflector'

Inflectior = ActiveSupport::Inflector

module Majic
  class Generator < Thor
    include Thor::Actions
    namespace :generate

    desc "project <name>", "Generate a new project."
    def project name
      @name = name

      directory 'templates/project', name

      inside name do
        run "bundle install"
        run "git init"
      end
    end

    no_commands do
      # Return the name.
      def name
        @name
      end

      # Return the undercase version of the name.
      def underscore_name
        @name.underscore
      end

      # Return the users full name (relies on `git config`)!
      def user_full_name
        %x{git config --global --get user.name}.strip
      end

      # Return the users e-mail address (relies on `git config`)!
      def user_email_address
        %x{git config --global --get user.email}.strip
      end
    end
  end
end

Majic::Generator.source_root File.dirname(__FILE__)
