# encoding: utf-8

module Majic
  module SizeUnits
    Units = %w{bytes kilobytes megabytes gigabytes terabytes}

    def bytes; self end
    def kilobytes; self * 1024 end
    def megabytes; self * 1024 ** 2 end
    def gigabytes; self * 1024 ** 3 end
    def terabytes; self * 1024 ** 4 end

    Units.each do |unit|
      plural = unit
      singular = plural.chop

      alias_method singular, plural
    end
  end

  Numeric.send :include, SizeUnits
end
